'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.add = add;
exports.get = get;

var _ = require('../../');

function add(tpl, json, type) {
  var obj = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];
  var date = arguments.length <= 4 || arguments[4] === undefined ? null : arguments[4];
  var realType = arguments.length <= 5 || arguments[5] === undefined ? 'draft' : arguments[5];

  var meta = _.config.meta.name;

  var currentDate = date != null && date !== '' ? date : new Date();
  var abeUrl = type === 'publish' ? json[meta].link : _.cmsData.fileAttr.add(json[meta].link, 'd' + _.cmsData.revision.removeStatusAndDateFromFileName(currentDate.toISOString())) + '';

  if (json[meta].date == null) {
    json[meta].date = currentDate;
  }
  json[meta].latest = {
    date: currentDate,
    abeUrl: abeUrl
  };
  json[meta].status = realType === 'reject' ? 'draft' : realType;
  if (json[meta][type] == null) {
    json[meta][type] = JSON.parse(JSON.stringify(obj));
    json[meta][type].date = currentDate;
    json[meta][type].abeUrl = abeUrl;
  }
  json[meta][type].latest = JSON.parse(JSON.stringify(obj));
  json[meta][type].latest.date = currentDate;
  json[meta][type].latest.abeUrl = abeUrl;
}

function get(arr) {
  var res = [];
  Array.prototype.forEach.call(arr, function (file) {
    var meta = _.config.meta.name;

    var jsonPath = _.cmsData.file.fromUrl(file.path).json.path;
    var json = _.cmsData.file.get(jsonPath);
    if (json[meta] == null) json[meta] = {};
    file['template'] = json[meta].template;
    if (json[meta].latest != null) {
      file['date'] = json[meta].latest.date;
    }
    if (json[meta].complete == null) {
      json[meta].complete = 0;
    }
    if (json[meta] != null) {
      file[_.config.meta.name] = json[meta];
    }
    res.push(file);
  });

  return res;
}