'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var create = function create(template, pathCreate, name, req) {
  var forceJson = arguments.length <= 4 || arguments[4] === undefined ? {} : arguments[4];
  var duplicate = arguments.length <= 5 || arguments[5] === undefined ? false : arguments[5];

  var p = new Promise(function (resolve, reject) {
    _.Hooks.instance.trigger('beforeCreate', template, pathCreate, name, req, forceJson);

    var templatePath = _.fileUtils.getTemplatePath(template.replace(_.config.root, ''));
    var filePath = _path2.default.join(pathCreate, name);
    filePath = (0, _.cleanSlug)(filePath);
    filePath = _.fileUtils.getFilePath(filePath);

    if (templatePath !== null && filePath !== null) {
      var tplUrl = _.FileParser.getFileDataFromUrl(filePath);

      if (!_.fileUtils.isFile(tplUrl.json.path)) {
        var json = forceJson ? forceJson : {};
        var tpl = templatePath;
        var text = _.cmsTemplate.template.getTemplate(tpl);
        if (duplicate) {
          json = _.cmsData.removeDuplicateAttr(text, json);
        }
        text = _.Util.removeDataList(text);
        var resHook = _.Hooks.instance.trigger('beforeFirstSave', filePath, req.query, json, text);
        filePath = resHook.filePath;
        json = resHook.json;
        text = resHook.text;

        _.Hooks.instance.trigger('afterCreate', json, text, pathCreate, name, req, forceJson);
        (0, _.save)(filePath, req.query.selectTemplate, json, text, 'draft', null, 'draft').then(function (resSave) {
          _.Manager.instance.updateList();
          filePath = resSave.htmlPath;
          tplUrl = _.FileParser.getFileDataFromUrl(filePath);
          resolve(resSave.json);
        }).catch(function (e) {
          reject();
          console.error(e);
        });
      } else {
        var json = _.FileParser.getJson(tplUrl.json.path);
        resolve(json, tplUrl.json.path);
      }
    } else {
      reject();
    }
  }).catch(function (e) {
    console.error(e);
    reject();
  });

  return p;
};

exports.default = create;