'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = remove;
exports.removeFile = removeFile;
exports.olderRevisionByType = olderRevisionByType;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function remove(filePath) {
  filePath = _.coreUtils.slug.clean(filePath);
  filePath = _.abeExtend.hooks.instance.trigger('beforeDeleteFile', filePath);

  var revisions = _.cmsData.revision.getVersions(filePath);

  Array.prototype.forEach.call(revisions, function (revision) {
    _.cmsOperations.remove.removeFile(revision.path, revision.htmlPath);
  });

  _.Manager.instance.updateList();
}

function removeFile(file, json) {
  if (_.coreUtils.file.exist(file)) {
    _fsExtra2.default.removeSync(file);
  }

  if (_.coreUtils.file.exist(json)) {
    _fsExtra2.default.removeSync(json);
  }
}

function olderRevisionByType(fileName, type) {
  var folder = fileName.split('/');
  var file = folder.pop();
  var extension = file.replace(/.*?\./, '');
  folder = folder.join('/');
  var stat = _fsExtra2.default.statSync(folder);
  if (stat) {
    var files = _.cmsData.file.getFiles(folder, true, 1, new RegExp('\\.' + extension));
    files.forEach(function (fileItem) {
      var fname = _.cmsData.fileAttr.delete(fileItem.cleanPath);
      var ftype = _.cmsData.fileAttr.get(fileItem.cleanPath).s;
      if (fname === file && ftype === type) {
        var fileDraft = fileItem.path.replace(/-abe-./, '-abe-d');
        _.cmsOperations.remove.removeFile(fileItem.path, _.coreUtils.file.changePath(fileItem.path, _.config.data.url).replace(new RegExp('\\.' + extension), '.json'));
        _.cmsOperations.remove.removeFile(fileDraft, _.coreUtils.file.changePath(fileDraft, _.config.data.url).replace(new RegExp('\\.' + extension), '.json'));
      }
    });
  }
}