'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.exist = exist;
exports.changePath = changePath;
exports.getContent = getContent;

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function exist(pathFile) {
  try {
    _fsExtra2.default.statSync(pathFile);
    return true;
  } catch (e) {
    return false;
  }

  return false;
}

function changePath(pathEnv, change) {
  pathEnv = pathEnv.replace(_.config.root, '').replace(/^\//, '').split('/');
  pathEnv[0] = change;

  return _path2.default.join(_.config.root, pathEnv.join('/'));
}

/**
 * This method checks that the path leads to a file and return the content as UTF-8 content
 * @param  {string} path The path
 * @return {string}      The content of the UTF-8 file
 */
function getContent(pathFile) {
  var res = null;
  if (typeof pathFile !== 'undefined' && pathFile !== null && pathFile !== '') {
    if (exist(pathFile)) {
      res = _fsExtra2.default.readFileSync(pathFile, 'utf8');
    }
  }
  return res;
}